#ifndef HEAP_H
#define HEAP_H
#include <map>
#include <vector>
#include <iostream>
using namespace std;

#define HEAP_EMPTY -1

/*m[hRXgmin-heapProperty𖞂悤
q[v\zthNXpnetworkNXɃANZXł悤ɂׂ...*/
typedef int id_S;
template<typename COST>
class Heap {
private:
	// heapɂ̓m[hAIDDY̓q[ṽCfbNX
	vector<id_S> heap;
	// costɂ̓m[hRXgDY͘AID
	vector<COST> heapCost;
	// reverseMapheap̋tDȂ킿CAIDCfbNX擾
	vector<int> reverseMap;

	//q[vւ
	void swap(int i1, int i2) {
		id_S tmp = heap[i1];
		reverseMap[heap[i1]] = i2;
		heap[i1] = heap[i2];
		reverseMap[heap[i2]] = i1;
		heap[i2] = tmp;
	}
	void dump(){
		cerr << "!" << endl;
	}
public:
	int heapIndex;
	
	Heap(int maxSize) {
		heapCost.assign(maxSize, 0);
		heap.assign(maxSize, 0);
		reverseMap.assign(maxSize, 0);
		heapIndex = 0;
	}

	// 󂩂ǂ
	inline bool isEmpty() {
		return (heapIndex == 0);
	}

	//[go
	id_S pop() {
		if (heapIndex == 0){
			return HEAP_EMPTY;
		} else {
			id_S ans = heap[0];
			//̗vf擪ɎĂăq[vč\z
			heap[0] = heap[heapIndex-1];
			reverseMap[heap[0]] = 0;
			heapIndex--;
			//[gRXgɏ]downheap
			downheap(0);
			return ans;
		}
	}

	// RXg
	void modifyCost(id_S id_, COST newcost) {
		if (heapCost[id_] > newcost) {
			heapCost[id_] = newcost;
			upheap(reverseMap[id_]);
		}else {
			heapCost[id_] = newcost;
			downheap(reverseMap[id_]);
		}
	}

	// RXgo
	COST getCost(id_S id_) {
		return heapCost[id_];
	}
	//CfbNX擾
	id_S getIndex(id_S id){
		return reverseMap[id];
	}
	
	//
	inline id_S extract(int index_){
		id_S ans = heap[index_];
		//̗vfł΂̂܂܏I
		if (heap[index_] == heap[heapIndex-1]){
			--heapIndex;
			return ans;
		}else{
		id_S tmp = heap[index_];
			//؂̖[̗vfĂ
			heap[index_] = heap[heapIndex-1];
			reverseMap[heap[index_]] = index_;
			//vf炷
			--heapIndex;
			downheap(index_);
			//L̑Ŗ؂ωȂ̂łupheap
			//minheappropertyĂΕKvȂ͂
			if (heap[index_]==tmp){
				upheap(index_);
			}
			return ans;
		}
	}

	//q[vɗvfi[
	void push(id_S id, COST heapCost_) {
		heap[heapIndex] = id;
		heapCost[id] = heapCost_;
		reverseMap[id] = heapIndex;
		upheap(heapIndex);
		heapIndex++;
	}

	/*----------\[g--------------*/
	//c[̔Cӂ̒n_烋[g܂Ń\[g
	void upheap(int from) {
		while (true) {
			//[gɂǂ蒅I
			if (from == 0){
				break;
			}
			int parent = (from - 1) / 2;
			
			//nodes̃CfbNX̍Ɗi[Ăm[hID͈̍v
			int diff = heap[parent]-heap[from];
			int findex = heap[from];
			double fcost = heapCost[findex];
			double pcost = heapCost[findex + diff];

			//e̕q傫Γւ
			if (fcost<pcost) {
				swap(from, parent);
				from = parent;
			}
			else break;
		}
	}
	//c[̔Cӂ̒n_疖܂Ń\[g
	inline void downheap(int from){
		int lchild = 0;
		int rchild = 0;
		int minchild = 0;
		//q[v̖ɒH܂ŌJԂ
		while (true) {
			lchild = from * 2 + 1;
			rchild = from * 2 + 2;
			//̎qȏł
			if (lchild >= heapIndex){
				break;
			}
			//q݂Ȃ
			if (rchild >= heapIndex){
				rchild = lchild;
			}
		
			//E̎qmr,qT
			double fcost = heapCost[heap[from]];
			double lcost = heapCost[heap[lchild]];
			double rcost = heapCost[heap[rchild]];
			
			minchild = (rcost < lcost) ? rchild : lchild;
			double mincost = heapCost[heap[minchild]];
			//e̕ΏI
			if (fcost <= mincost){
				break;
			}else{
				swap(from, minchild);
				from = minchild;
			}
		};
	}
};

#endif